=== debian/changelog ===
dracut (110-3ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
    - dracut-core: Declare breaking rust-coreutils before version 0.5.0
    - autopkgtest: explicitly depend on libarchive13t64

 -- Benjamin Drung <bdrung@ubuntu.com>  Fri, 27 Feb 2026 20:58:13 +0100

dracut (110-3) unstable; urgency=medium

  [ Hector Cao ]
  * test: force cpu to neoverse-n1 for arm64 when QEMU_CPU not set
    (Closes: #1128969, LP: #2142121)

 -- Benjamin Drung <bdrung@debian.org>  Thu, 26 Feb 2026 17:08:57 +0100

dracut (110-2) unstable; urgency=medium

  * Run MD RAID test cases in test 70 and 71 again (fixed in mdadm 4.5-5)
  * fix(multipath): include Debian-specific priority of udev rules until
    Debian and upstream agrees on one common numbering (see LP 2137190)
  * Build-depend on libsystemd-dev to build dracut-install with JSON support
    (Closes: #1128349)
  * Apply upstream patches to fix failing autopkgtest 14-hooks on Ubuntu:
    - fix(kernel-modules-export): use return instead of exit in pre-pivot hook
    - fix(memdisk): use return instead of exit in cmdline hook
    - fix(ppcmac): use return instead of exit in pre-udev hook
    - fix(syslog): use return instead of exit in initqueue/online hook
  * dracut-test: add run-qemu and test-functions
  * autopkgtest: Doule timeout to 20 min for slow architectures armhf, riscv64

 -- Benjamin Drung <bdrung@debian.org>  Mon, 23 Feb 2026 14:25:02 +0100

dracut (110-1ubuntu2) resolute; urgency=medium

  * Drop test-skip-failing-MD-RAID-tests-cases-in-test-70-and-71.patch
  * Apply patches to fix failing autopkgtest 14-hooks:
    - fix(kernel-modules-export): use return instead of exit in pre-pivot hook
    - fix(memdisk): use return instead of exit in cmdline hook
    - fix(ppcmac): use return instead of exit in pre-udev hook
    - fix(syslog): use return instead of exit in initqueue/online hook

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 11 Feb 2026 17:43:47 +0100

dracut (110-1ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
    - dracut-core: Declare breaking rust-coreutils before version 0.5.0
  * autopkgtest: run 43-kernel-install on arm64 again (LP: #2133402)
  * dracut-test: add run-qemu and test-functions
  * autopkgtest: depend on libarchive13t64 (fixed in systemd 259.1-1)

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 09 Feb 2026 13:20:58 +0100

dracut (110-1) unstable; urgency=medium

  * New upstream release.
  * Drop all patches applied upstream
  * dracut-core:
    - remove dropped uki-virt and no-xattr Dracut config
    - remove merged dracut-init.sh and dracut-version.sh
    - rename systemd-pcrphase to systemd-pcrextend
    - order systemd-cryptsetup after crypt Dracut module
    - add new memdisk Dracut module
  * dracut-network:
    - add new systemd-import Dracut module and suggest systemd-container for it
    - Drop network-legacy dracut module (and isc-dhcp-client support)
  * autopkgtest: add new upstream tests 14-hooks, 21-overlayfs, 31-livenet,
    and 45-systemd-import
  * autopkgtest: do not require make for running upstream tests
  * test: skip failing MD RAID tests cases in test 70 and 71 (mdadm 4.5 bug)

 -- Benjamin Drung <bdrung@debian.org>  Mon, 09 Feb 2026 02:05:10 +0100

dracut (109-11ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - autopkgtest: skip failing 43-kernel-install on arm64 (see LP 2133402)
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
    - dracut-core: Declare breaking rust-coreutils before version 0.5.0

 -- Benjamin Drung <bdrung@ubuntu.com>  Wed, 04 Feb 2026 01:04:58 +0100

dracut (109-11) unstable; urgency=medium

  * autopkgtest: explicitly depend on dmsetup for test 60-nfs

 -- Benjamin Drung <bdrung@debian.org>  Fri, 30 Jan 2026 22:36:56 +0100

dracut (109-10) unstable; urgency=medium

  * Let firmware package updates trigger the dracut autopkgtest
  * dracut-core: document which Dracut module needs suggested packages
  * Merge dracut-squash into dracut-core
  * Move the livenet Dracut module to dracut-network and merge the remaining
    dracut-live into dracut-core
  * fix(tpm2-tss): add tss user/group in addition to sysusers config
    (LP: #2127725)
  * autopkgtest: depend on erofs-utils and xorriso in test 30

 -- Benjamin Drung <bdrung@debian.org>  Fri, 30 Jan 2026 15:08:55 +0100

dracut (109-9ubuntu1) resolute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Let linux-firmware updates trigger the dracut autopkgtest
    - autopkgtest: skip failing 43-kernel-install on arm64 (see LP 2133402)
    - autopkgtest: skip too slow 41-full-systemd on arm64 and armhf
      (see LP 2133401)
  * Dropped changes:
    - dracut-core: demote binutils to suggests. its only needed when using UEFI
      executables
    - fix(udev-rules): exclude udev rules from snapd. Let snapd ship a Dracut
      config file instead (see LP 2139065)
    - feat(dmsquash-live-autooverlay): support readlink from uutils
      (fixed by rust-coreutils 0.5.0)
    - test: use GNU dd instead of uutil's dd (to work around bug LP 2129037)
      (fixed by rust-coreutils 0.4.0)
  * dracut-core: Declare breaking rust-coreutils before version 0.5.0

 -- Benjamin Drung <bdrung@ubuntu.com>  Mon, 26 Jan 2026 11:47:44 +0100

dracut (109-9) unstable; urgency=medium

  * feat: warn in case 3cpio is present but not suitable (Closes: #1125948)
  * dracut-core: Prefer 3cpio over cpio again

 -- Benjamin Drung <bdrung@debian.org>  Sat, 24 Jan 2026 19:43:56 +0100

dracut (109-8) unstable; urgency=medium

  [ Bastian Blank ]
  * Revert to use cpio. (closes: #1125948)

  [ Benjamin Drung ]
  * Drop unneeded udevsettle patch (see upstream issue 2067)


